# Preface

Hey this is sivarajan. I'm happy to present to you the Digiline tutorial page. This contains all the basics for a beginner to meddle with digilines. Digilines are powerful tools used for sending and receiving data, and conducting through wires. I hope this book will be a guide to begin Digilines. Thanks to 56independent for helping me to fix grammar errors in this documentation.Thanks for reading this book.If you find it hard to read this document contact me. All contributions are welcome.  

# Chapter 1: Introduction to digilines.

Digilines is a mod by Jieja. It consists of:

- RTC (Real Time Clock): to get the in-game time.
- LCD : display text.
- light sensor: for sensing light level.
- Chest: inform players what is inside it . 

Some mods that use diglines: Digiterms(not included in this server), Pipeworks , Technic , Mescons. Mesecons are needed since we need Lua controller to control our Diglines.

Crafting:
Look at your inventory for details.

Knowledge about lua controllers and lua is required to begin this.
- A guide to use lua controller: https://mesecons.net/luacontroller/
- Lua programming guide: https://www.tutorialspoint.com/lua/
In future there will be a guide to lua controllers.

# Chapter 2 : Hello world

### Introduction:
First of all let us learn how to send a basic digiline message.For that we use digiline functions. It should look like this:
```
    digiline_send(<channelname>,<message>)
```
Where:
- channelname - name of the channel as String. You can give any name for your channel but remember it should be the same when you are trying to interact with other digiline components. 
- message - It holds the message to be sent. (Either a string or a table). This message is 

### Apparatus required:
-   Lua controller
-   digiline cable
-   digiline LCD display. 


### Steps to print hello world with Lua controller circuit:

1. Place the LCD and Lua contoller
2. right click the digiline LCD
3. set the channel to "tv". Click proceed.
4. connect the digiline LCD to the lua controller via digilines
5. right click the Lua controller.Type the code below

### Code:

```
    digiline_send("tv","Hello World!")

```

# Chapter 3 : your own digiline Clock:

### Introduction
In this tutorial We are going to make use of the function os.datetable(). 

### Apparatus required:

- LUA controller
- Digiline Display
- Digiline Wire 

### Circuit:
(if you have not destroyed your previous Apparatus, skip the following) 
1. Place the lcd, and set the channel to "tv". 
2. place a luacontroller, somewhere else, and connect them both using a digline wire. 

### Code:
```
interrupt(1)
if event.type== "interrupt" then
    time = os.datetable()
    -- this is a built in fuction that returns time
    digiline_send("tv",time.hour..":"..time.min..":"..time.sec)
    -- to run press execute in lua controller
end
```
# Chapter 4: Communication between two or more LUA controllers using Digiline.

### Introduction: 
In this chapter we are going to see how to recieve/send digiline messages using lua controller by an example code. 

#### Event tables
it is a table generated by the lua controller  when a particular event is recoginzed by the LUA controller. 
the event table looks like this:

```
        event ={
        type =""
        [Variables] =[values]
        }
```

### Connection: 
1. Connect the Lua controllers with digilines. 
2. Connect the Slave Lua controller to the LCD display. Set the channel of the LCD to "TV". Code:

### Code
#### Master/sender:
```
    digiline_send("ch","Hi")
```
#### Slave:
```
if event.type =="digiline" then
        --TV is channel of LCD
        digiline_send("TV","channel: " .. event.channel ..
                    "message: " .. event.msg)
    end
```
Where: 
event is table generated by lua controller.Here the received event table will be like this:
```
event={
    type = "digiline",
    channel ="ch"
    msg ="hi"
}

```

Click Execute on Slave first and then click execute on Master. you can see the following output on the digiline display:

Channel:ch

Message: hi



Note : a digiline message ie event.msg. can be in the form of a Table. it must be noted that we cannot print a table. We can only print a particular value of the table. Say this code is executed by the master digiline:

```
digiline_send("ch",{a=1,b=2})
```

In that case the Table will be
```
event = {
    type ="digiline"
    msg= {
        a=1,
        b=2
        }
    }  
```
So if we try to print the msg on a digiline display, it will show an error: Message is too complex. But you can print a table to the command line (works if you have server privs). by using print() function in Lua. Note that minetest must be started using commandline. Or you can use digiline termial to print values.

# Chapter 5: Digline Injector and Autocrafter

### Introduction
In this chapter we are going to learn about controlling autocrafters and digiline injectors of Pipeworks using the Lua controller.

## 5.1 Auto crafter

### Introduction: 
The autocrafter is a useful tool when it comes to automation. If you put a crafting recipe in the 3*3 box, and place materials in the large box at the bottom, it will commence automatically crafting stuff (hence its name).

To control auto crafter using lua controller:

-   Place Lua controller near the Autocrafter/ Connect them with digiline wire.
-   In auto crafter type the channel name (say c).
-   Now send a 3*3 table to the autocrafter. It will look like this:
```
    digiline_send("<channel>",{
    {"node1","node2","node3"}
    , {"node4","node5","node6"}
    ,{"node7","node8","node9"}})
```
### Note: 
- If there should be no node in the grid type e in place of nodeN. 
- Format of nodeN is modname:nodename it can be checked in the inventory.
- Send "on " to the autocrafter channel to turn it on. 
- Send "off" to the autocrafter channel to turn it off.

## 5.2 Digiline Injectors
### Introduction: 
The injector is another useful component of pipeworks. It is used to eject the items out of a chest. We are going to learn how to control the digiline injector using lua controller. The advantage of digiline injector is it can be used as item-wise filter injector or stack-wise filter injector

### Instructions to use.
Craft a digiline injector and connect it with lua controller. Now here is the digiline table requests format to be sent to injector:
```
{
    slotseq = "priority",
    -- priority | random | rotation 
    exmatch = true,
    -- true | false
    name = name,
    -- here we give the node name to be sent.
    count = count,
    -- no of count of node to be sent.
}
```
Where:
- slotseq: defines the order of items to be sent.
- exmatch: enables excat match flag on injector.
- name   : name of the node to be sent.
- count  : number of node to be sent.



### Some example codes:

#### Operating as a stack wise injector:
```
    interrupt(1) -- pulse delay
    if event.type == "interrupt" then
        digiline_send("injector",{}) --or {count =99}
    end
```
#### Operating it as an item wise injector:

```
    interrupt(1)
    if event.type =="interrupt" then
        digiline_send("injector",{count =1})
    end
```

#### Send only default:stone by the injector.

```
    interrupt(1)
    if event.type=="interrupt" then
        digiline_send("injector",{name="default:stone"})
    end 
```

# Chapter 6: Digiline Chest

### Introduction: 
A digiline chest is a powerful node that says what stuff is put/moved/taken from it.

### Event tables generated by digiline chest.
let's see how the event tables look by seeing examples.

Here the digiline channel for all event table will be "d".

#### A node (Default:stone99):
```
    event = {
        type = "digiline",
        channel = "d",
        msg = {
             stack = {
             meta = {
                 -- this field contains additonal memory for the node
             },
             metadata = "",
             count = 99,
             name = "default:stone",
             --name and count  will chage according to the node
             wear = 0
             -- this is the condition of the tool
        },
        action = "uput",
        to_slot = 1 --denotes which slot the stuff is
        }
    }
```
### A Technic node with charge (Blue energy Crystal)
```
    event ={
        type = "digiline",
        channel = "d",
        msg = {
             stack = {
                 meta = {

                 },
                 metadata = "return {[\"charge\"] = 450000}",
                 -- charge tells the amout of charge that  crystal
                 count = 1,
                 name = "technic:blue_energy_crystal",
                 wear = 1
            },
            action = "uput",
            to_slot = 2
        }
    }
```

#### A book with Title "my book" of content: hello world
```
    event ={
        type = "digiline",
        channel = "d",
        msg = {
            stack = {
                meta = {
                    owner = "sivarajan",
                    title = "my book",
                    page_max = "1",
                    text = "hello \ world",
                    -- \represents a new line in a book
                    page = "1",
                    description = "\27(T@default)\"\27Fmy book\27E\" by \27Fsivarajan\27E\27E"
                    --this is the text shown to other players viewing the book
                },
                metadata = "",
                count = 1,
                name = "default:book_written",
                wear = 0
            },
            action = "umove",
            from_slot = 11,
            -- when moving stuff read the Notes
            to_slot = 3
        }
    }
```

Note:

action takes the value :

- "uput" - when you put stuff inside the chest.
- "tput" - when a tube puts stuff inside the chest.
- "empty" - when digiline chest is empty*.
- "utake"- when you take stuff from inside the chest.
- "ttake" - when a tube takes stuff from inside the chest.
- "full" - when the digiline chest is full*
- "umove"- moving stuff from one slot to another.
- * /!\ be careful : "empty" and "full" action messages are sent just after "*take" and "*put" one !

from_slot says from which slot the node is moved

to_slot says in which slot the node is placed.

from_slot is available when moving a stuff inside the chest.



# Chapter 7 Digilines and Technic

### Introduction
This chapter describes how to interface technic components to digilines. We can get the data of these technic machines to make useful things like a system that warns when the supply is at 0.

## 7.1 Switches

A switching station is an important node that connects all of your techinc components. It sends the EU (Electronic Units) supply and EU demand to the digiline controller (LUA controller). A channel name for a switching station can be set by right clicking on it. Its event table will be in form of :
```
event{
    type="digiline",
    channel=""
    msg={
        supply = (integer value)
        demand = (integer value)
    }
}
-- to get this you must send GET String to the switching station. This is decribed in 1.4.
```

## 7.2 Supply converter

It converts HV power to LV power, MV to LV,HV to MV Vise versa.(MV is not available in this server). The Channel of the converter can be set by right clicking on it and renaming the default channel. General form of Event table:
```
event ={
type= "digiline"
msg={
	mesecon_mode = (intergervalue),
	enabled = (integervalue),
	power = (integervalue)
    }
}
```
Messages that can be sent:
1. "on": turn on the power supply
2. "off": turn off the supply
3. "toggle": Change the state of supply
4. "GET": get the state of supply converter(returned as a Table).

## 6.3 Batteries

HV and Lv batteries store charge here is a example event table sent by the batteries:
```
event ={
    type = "digiline",
    channel = "",
    msg = {
        input = (integer),
        --input voltage
        supply = 40000,-
        --upgrade 1 and 2 are availabe only for HV tools
        upgrade1 = {
            meta = {

            },
            metadata = "",
            count = 1,
            name = "",
            -- here the node will be a valid upgrade node
            wear = 0
        },
        upgrade2 = {
            meta = {

            },
            metadata = "",
            count = 1,
            name = "technic:battery",
            wear = 0
        },
        demand = (integervalue)
        charge = (integer value),
        -- amount of charge it contains
        max_charge = (integer),
        -- maximum charge
        src = {
            meta = {

            },
            metadata = "return {[\"charge\"] = }",
            count = 1,
            name = "technic:",
            wear = (integervalue)
        }
    }
}
```
## 7.4 Interfacing Technic and Digiline

This is an example for using techic data in digiline. Here we are printing the demand in a digiline LCD

### Items required:

- Blinky Plant.
- Any Technic node. In this case, a Switching station.
- Digiline LCD.
- LUA controller.
- Digiline and Mesecon wires. 

### Procedure:

1. Connect the switching station and digiline display seperately with Lua Controller and digiline cable.
2. Connect blinky plant in seperate port with mesecon wire.
3. Assign the channel Name of the switching station and LCD as ch and LCD respectively or any name that you prefer. 

### Code:
```
-- change the channel according to your needs
if event.type=="program" or event.type =="on" then
    -- event on triggered when mesecon signal is obtained by Lua Controller
    -- event program is triggered when execute button is clicked
    digiline_send("ch","GET") --sending GET to ch
    elseif event.type =="digiline" then
        digiline_send("LCD",event.msg.demand)
end
```
